# This Python file uses the following encoding: utf-8
'''
Created on May 13, 2011

Test the deduction iterator

@author: mjacob
'''
from unittest.case import TestCase
from mjacob.algorithms.deduction_iterator import deductions

class DeductionIteratorTest(TestCase):
    def __do_test(self, start, A, output):
        result = set(deductions(start, A.__getitem__))
        self.assertEqual(result, output, "unexpected output\n%s\n%s" % (result, output))
    
    def test_a(self):
        output = set((
                      ((1, (2,)), (2, (3,)), (3, (4,)), (4, ())),
                      ((1, (2,)), (2, (3,)), (3, (5,)), (5, (6,)), (6, ())),
                      ((1, (2,)), (2, (3,)), (3, (6,)), (6, ())),
                      ((1, (2,)), (2, (4,)), (4, ())),
                      ((1, (2, 3)), (2, (3,)), (3, (4,)), (4, ())),
                      ((1, (2, 3)), (2, (3,)), (3, (5,)), (5, (6,)), (6, ())),
                      ((1, (2, 3)), (2, (3,)), (3, (6,)), (6, ())),
                      ((1, (2, 3)), (2, (4,)), (4, ()), (3, (4,))),
                      ((1, (2, 3)), (2, (4,)), (4, ()), (3, (5,)), (5, (6,)), (6, ())),
                      ((1, (2, 3)), (2, (4,)), (4, ()), (3, (6,)), (6, ())),
                      ((1, (3,)), (3, (4,)), (4, ())),
                      ((1, (3,)), (3, (5,)), (5, (6,)), (6, ())),
                      ((1, (3,)), (3, (6,)), (6, ())),
                    ))
        start, A = 1, {1: ((2,),(2,3,),(3,),), 2: ((3,),(4,),), 3: ((4,),(5,),(6,),), 4: ((),), 5: ((6,),), 6: ((),)}
        self.__do_test(start, A, output)
        
    def test_b(self):
        output = set((
                      ((1, (2, 3)), (2, (3,)), (3, (4,)), (4, ())),
                      ((1, (2, 3)), (2, (3,)), (3, (4, 5)), (4, ()), (5, ())),
                      ((1, (2, 3)), (2, (4,)), (4, ()), (3, (2,))),
                      ((1, (2, 3)), (2, (4,)), (4, ()), (3, (4,))),
                      ((1, (2, 3)), (2, (4,)), (4, ()), (3, (4, 5)), (5, ())),
                    ))
        start, A = 1, {1: ((2,3,),), 2: ((3,), (4,),), 3: ((2,), (4,), (4,5,),), 4: ((),), 5: ((),)}
        self.__do_test(start, A, output)
        
    def test_c(self):
        output = set((
                      ((1, (2, 3)), (2, (3,)), (3, (4,)), (4, ())),
                      ((1, (2, 3)), (2, (4,)), (4, ()), (3, (2,))),
                      ((1, (2, 3)), (2, (4,)), (4, ()), (3, (2, 4))),
                      ((1, (2, 3)), (2, (4,)), (4, ()), (3, (4,))),
                    ))
        start, A = 1, {1: ((2,3,),), 2: ((3,), (4,),), 3: ((2,), (2,4,), (4,),), 4: ((),)}
        self.__do_test(start, A, output)
        
    def test_d(self):
        output = set((
                      ((12, (13, 6)), (13, (3,)), (3, ()), (6, (2, 18)), (2, (10, 11)), (10, ()), (11, ()), (18, (37,)), (37, (30, 0)), (30, ()), (0, ())),
                    ))
        start, A = 12, {0: ((),), 1: ((2,),), 2: ((10, 11),), 3: ((),), 4: ((5, 6),), 5: ((8, 9),), 6: ((2, 18),), 7: ((5, 1),), 8: ((),), 9: ((),), 10: ((),), 11: ((),), 12: ((13, 6),), 13: ((3,),), 14: ((13,),), 15: ((5,),), 16: ((),), 17: ((13, 1),), 18: ((37,),), 19: ((),), 20: ((21,),), 21: ((),), 22: ((20,),), 23: ((24,),), 24: ((),), 25: ((23,),), 26: ((),), 27: ((),), 28: ((),), 29: ((30, 31),), 30: ((),), 31: ((),), 32: ((29,),), 33: ((30, 34),), 34: ((),), 35: ((10, 16),), 36: ((35,),), 37: ((30, 0),), 38: ((35, 32),), 39: ((20, 32),), 40: ((33,),)}
        self.__do_test(start, A, output)
        
    